unit formBasicStateMachine;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs,classBaseStateMachine, ExtCtrls, StdCtrls;

const
  STATE_COUNTINGUP   = 1;
  STATE_COUNTINGDOWN = 2;

type
  TMyStateMachine = class(TBaseStateMachine)
  protected
    fCounter        : integer;
  public
    procedure initialiseStates; override;

    function stateCountingUp:integer;
    function stateCountingDown:integer;

    property counter:integer read fCounter;
  end;

  TfrmBasicStateMachine = class(TForm)
    lblCountTitle: TLabel;
    lblCurrentStateTitle: TLabel;
    lblCount: TLabel;
    lblCurrentState: TLabel;
    tmrTick: TTimer;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure tmrTickTimer(Sender: TObject);
  private
    { Private declarations }
    fMyStateMachine : TMyStateMachine;

  public
    { Public declarations }

  end;

var
  frmBasicStateMachine: TfrmBasicStateMachine;

implementation

{$R *.dfm}




//------------------------------------------------------------------------------

procedure TMyStateMachine.initialiseStates;
begin
  addState(STATE_COUNTINGUP,stateCountingUp);
  addState(STATE_COUNTINGDOWN,stateCountingDown);

  fCurrentState:=STATE_COUNTINGUP;
  fCounter:=0;
end;

function TMyStateMachine.stateCountingUp;
begin
  result:=0;
  inc(fCounter);

  if (fCounter>=100) then
  begin
    result:=STATE_COUNTINGDOWN;
  end;
end;

function TMyStateMachine.stateCountingDown;
begin
  result:=0;
  dec(fCounter);

  if (fCounter<=0) then
  begin
    result:=STATE_COUNTINGUP;
  end;
end;

procedure TfrmBasicStateMachine.FormCreate(Sender: TObject);
begin
  fMyStateMachine:=TMyStateMachine.create;
end;

procedure TfrmBasicStateMachine.FormDestroy(Sender: TObject);
begin
  try
    fMyStateMachine.free;
  except
  end;
end;

procedure TfrmBasicStateMachine.tmrTickTimer(Sender: TObject);
begin
  tmrTick.enabled:=false;

  fMyStateMachine.process;

  lblCount.caption:=intToStr(fMyStateMachine.counter);
  lblCurrentState.caption:=intToStr(fMyStateMachine.currentState);

  tmrTick.enabled:=true;
end;

end.
